#methods related to color, for example translation between different color spaces

def hsl_to_rgb *p
#	raise "Given parameter should be an array or hue, saturation and lightness listed!" if p.class != Array
	p = p.flatten
	raise "Three values (hue, saturation and lightness) should be provided!" if p.length != 3
	raise "Hue should be in 0..359 and both saturation and lightness in 0..255!" unless p.zip([0..359]+[0..255]*2).all? {|i|i[1].include? i[0]}
	
#	puts p.inspect
	
	c = (1.0 - (p[2].to_f / 128.0 - 1.0).abs) * p[1].to_f / 256.0
	t = (p[0] / 60.0)
	x = c * (1.0 - (t % 2 - 1.0).abs)
	
#	puts "c: #{c}\tt: #{t}\tx: #{x}"
	
	r,g,b = case t.to_i
		when 0
			[c,x,0]
		when 1
			[x,c,0]
		when 2
			[0,c,x]
		when 3
			[0,x,c]
		when 4
			[x,0,c]
		when 5
			[c,0,x]
	end
	
#	puts [r,g,b].inspect
	
	m = p[2] / 256.0 - 0.5 * c
	return [r,g,b].map {|i| ((i + m) * 255).to_i}
end
