=begin
@author	Ville Kumpulainen

Class implementing distance function in different metric spaces.

@todo	Hamming distance could probably be one of the most useful not yet implemented (http://en.wikipedia.org/wiki/Metric_space#Examples_of_metric_spaces)
=end

class Metric
	MANHATTAN = 1
	EUCLIDEAN = 2
	CHEBYSHEV = 999
	
	def self.distance p1, p2, metric = EUCLIDEAN
		return case metric
			when MANHATTAN
				(p1.zip(p2).map{|v|v.inject(:-)}).inject(0) { |sum,d| sum += d.abs }
			when EUCLIDEAN
				((p1.zip(p2).map{|v|v.inject(:-)}).inject(0) { |sum,d| sum += d**2 }) ** 0.5
			when CHEBYSHEV
				(p1.zip(p2).map{|v|v.inject(:-)}).inject(0) { |max,d| if max < d.abs then max = d.abs end; max }
			else
				raise "Metric #{metric} not implemented!"
		end
	end
end
